## crossbar 21.3.1+dfsg

=== Makefile ===
.PHONY: test docs

all:
	@echo "Targets:"
	@echo ""
	@echo "   clean            Cleanup"
	@echo "   test             Run unit tests"
	@echo "   flake8           Run flake tests"
	@echo "   install          Local install"
	@echo "   publish          Clean build and publish to PyPI"
	@echo "   docs             Build and test docs"
	@echo "   prepareUbuntu    Prepare running tests on Ubuntu"
	@echo ""

clean:
	rm -rf ./build
	rm -rf ./dist
	rm -rf ./crossbar.egg-info
	rm -rf ./.crossbar
	-find . -type d -name _trial_temp -exec rm -rf {} \;
	rm -rf ./tests
	rm -rf ./.tox
	rm -rf ./vers
	rm -f .coverage.*
	rm -f .coverage
	rm -rf ./htmlcov
	-rm -rf ./_trial*
	-rm -rf ./pip-wheel-metadata
	-rm -rf ./docs/_build
	find . -name "*.db" -exec rm -f {} \;
	find . -name "*.pyc" -exec rm -f {} \;
	find . -name "*.log" -exec rm -f {} \;
	# Learn to love the shell! http://unix.stackexchange.com/a/115869/52500
	find . \( -name "*__pycache__" -type d \) -prune -exec rm -rf {} +

logs_service:
	sudo journalctl -f -u github-actions-crossbar.service

# Targets for Sphinx-based documentation
#

#docs:
#	sphinx-build -b html docs docs/_build

# spellcheck the docs
#docs_spelling:
#	sphinx-build -b spelling -d docs/_build/doctrees docs docs/_build/spelling

docs:
	cd docs && sphinx-build -b html . _build

docs_check:
	cd docs && sphinx-build -nWT -b dummy . _build

docs_spelling:
	cd docs && sphinx-build -nWT -b spelling -d ./_build/doctrees . ./_build/spelling

docs_run: docs
	twistd --nodaemon web --path=docs/_build --listen=tcp:8090

docs_clean:
	-rm -rf ./docs/_build


# freeze our dependencies
freeze:
	# do everything in a fresh environment
	rm -rf vers
	virtualenv vers

	# install and freeze latest versions of minimum requirements
	vers/bin/pip3 install -U "pip==19.3.1"
	vers/bin/pip3 install -r requirements-min.txt
	vers/bin/pip3 freeze --all | grep -v -e "wheel" -e "pip" -e "distribute" > requirements-pinned.txt

	# persist OSS license list of our exact dependencies
	vers/bin/pip3 install pip-licenses
	vers/bin/pip-licenses --from=classifier -a -o name > crossbar/LICENSES-OSS

	# hash all dependencies for repeatable builds
	vers/bin/pip3 install hashin
	-rm requirements.txt
	cat requirements-pinned.txt | xargs vers/bin/hashin > requirements.txt


wheel:
	LMDB_FORCE_CFFI=1 SODIUM_INSTALL=bundled pip wheel --require-hashes --wheel-dir ./wheels -r requirements.txt

# install for development, using pinned dependencies, and including dev-only dependencies
install:
	-pip uninstall -y crossbar
	pip install --no-cache --upgrade -r requirements-dev.txt
	pip install -e .
	@python -c "import crossbar; print('*** crossbar-{} ***'.format(crossbar.__version__))"

# install using pinned/hashed dependencies, as we do for packaging
install_pinned:
	-pip uninstall -y crossbar
	LMDB_FORCE_CFFI=1 SODIUM_INSTALL=bundled pip install --ignore-installed --require-hashes -r requirements.txt
	pip install .
	@python -c "import crossbar; print('*** crossbar-{} ***'.format(crossbar.__version__))"

# upload to our internal deployment system
upload: clean
	python setup.py bdist_wheel
	aws s3 cp dist/*.whl s3://fabric-deploy/

# publish to PyPI
publish: clean
	python setup.py sdist bdist_wheel
	twine upload dist/*

test_trial: flake8
	trial crossbar

test_full:
	crossbar \
		--personality=standalone \
		--debug-lifecycle \
		--debug-programflow\
		start \
		--cbdir=./test/full/.crossbar

test_manhole:
	ssh -vvv -p 6022 oberstet@localhost

gen_ssh_keys:
#	ssh-keygen -t ed25519 -f test/full/.crossbar/ssh_host_ed25519_key
	ssh-keygen -t rsa -b 4096 -f test/full/.crossbar/ssh_host_rsa_key

test_coverage:
	tox -e coverage .

test:
	tox -e sphinx,flake8,py36-unpinned-trial,py36-cli,py36-examples,coverage .

test_bandit:
	tox -e bandit .

test_cli:
	./test/test_cli.sh

test_cli_tox:
	tox -e py36-cli .

test_examples:
	tox -e py36-examples .

test_mqtt:
#	trial crossbar.adapter.mqtt.test.test_wamp
	trial crossbar.adapter.mqtt.test.test_wamp.MQTTAdapterTests.test_basic_publish

test_router:
	trial crossbar.router.test.test_broker
	#trial crossbar.router.test.test_router

test_testament:
	trial crossbar.router.test.test_testament

test_auth_ticket:
	trial crossbar.router.test.test_authorize.TestDynamicAuth.test_authextra_ticket

test_auth:
	trial crossbar.router.test.test_authorize

test_reactors:
	clear
	-crossbar version --loglevel=debug
	-crossbar --reactor="select" version --loglevel=debug
	-crossbar --reactor="poll" version --loglevel=debug
	-crossbar --reactor="epoll" version --loglevel=debug
	-crossbar --reactor="kqueue" version --loglevel=debug
	-crossbar --reactor="iocp" version --loglevel=debug

full_test: clean flake8
	trial crossbar

# This will run pep8, pyflakes and can skip lines that end with # noqa
flake8:
	flake8 --ignore=E117,E402,F405,E501,E722,E741,E731,N801,N802,N803,N805,N806 crossbar

flake8_stats:
	flake8 --statistics --max-line-length=119 -qq crossbar

version:
	PYTHONPATH=. python -m crossbar.controller.cli version

pyflakes:
	pyflakes crossbar

pep8:
	pep8 --statistics --ignore=E501 -qq .

pep8_show_e231:
	pep8 --select=E231 --show-source

autopep8:
	autopep8 -ri --aggressive --ignore=E501 .

pylint:
	pylint -d line-too-long,invalid-name crossbar

find_classes:
	find crossbar -name "*.py" -exec grep -Hi "^class" {} \; | grep -iv test

# sudo apt install gource ffmpeg
gource:
	gource \
	--path . \
	--seconds-per-day 0.15 \
	--title "crossbar" \
	-1280x720 \
	--file-idle-time 0 \
	--auto-skip-seconds 0.75 \
	--multi-sampling \
	--stop-at-end \
	--highlight-users \
	--hide filenames,mouse,progress \
	--max-files 0 \
	--background-colour 000000 \
	--disable-bloom \
	--font-size 24 \
	--output-ppm-stream - \
	--output-framerate 30 \
	-o - \
	| ffmpeg \
	-y \
	-r 60 \
	-f image2pipe \
	-vcodec ppm \
	-i - \
	-vcodec libx264 \
	-preset ultrafast \
	-pix_fmt yuv420p \
	-crf 1 \
	-threads 0 \
	-bf 0 \
	crossbar.mp4

# Some prerequisites needed on ubuntu to run the tests.
prepareUbuntu:
	sudo apt install libsnappy-dev
	sudo apt install python-tox

=== requirements.txt ===
appdirs==1.4.4 \
    --hash=sha256:7d5d0167b2b1ba821647616af46a749d1c653740dd0d2415100fe26e27afdf41 \
    --hash=sha256:a841dacd6b99318a741b166adb07e19ee71a274450e68237b4650ca1055ab128
argon2-cffi==20.1.0 \
    --hash=sha256:05a8ac07c7026542377e38389638a8a1e9b78f1cd8439cd7493b39f08dd75fbf \
    --hash=sha256:0bf066bc049332489bb2d75f69216416329d9dc65deee127152caeb16e5ce7d5 \
    --hash=sha256:18dee20e25e4be86680b178b35ccfc5d495ebd5792cd00781548d50880fee5c5 \
    --hash=sha256:392c3c2ef91d12da510cfb6f9bae52512a4552573a9e27600bdb800e05905d2b \
    --hash=sha256:57358570592c46c420300ec94f2ff3b32cbccd10d38bdc12dc6979c4a8484fbc \
    --hash=sha256:6678bb047373f52bcff02db8afab0d2a77d83bde61cfecea7c5c62e2335cb203 \
    --hash=sha256:6ea92c980586931a816d61e4faf6c192b4abce89aa767ff6581e6ddc985ed003 \
    --hash=sha256:77e909cc756ef81d6abb60524d259d959bab384832f0c651ed7dcb6e5ccdbb78 \
    --hash=sha256:7d455c802727710e9dfa69b74ccaab04568386ca17b0ad36350b622cd34606fe \
    --hash=sha256:8a84934bd818e14a17943de8099d41160da4a336bcc699bb4c394bbb9b94bd32 \
    --hash=sha256:9bee3212ba4f560af397b6d7146848c32a800652301843df06b9e8f68f0f7361 \
    --hash=sha256:9dfd5197852530294ecb5795c97a823839258dfd5eb9420233c7cfedec2058f2 \
    --hash=sha256:b160416adc0f012fb1f12588a5e6954889510f82f698e23ed4f4fa57f12a0647 \
    --hash=sha256:ba7209b608945b889457f949cc04c8e762bed4fe3fec88ae9a6b7765ae82e496 \
    --hash=sha256:cc0e028b209a5483b6846053d5fd7165f460a1f14774d79e632e75e7ae64b82b \
    --hash=sha256:d8029b2d3e4b4cea770e9e5a0104dd8fa185c1724a0f01528ae4826a6d25f97d \
    --hash=sha256:da7f0445b71db6d3a72462e04f36544b0de871289b0bc8a7cc87c0f5ec7079fa \
    --hash=sha256:e2db6e85c057c16d0bd3b4d2b04f270a7467c147381e8fd73cbbe5bc719832be
attrs==20.3.0 \
    --hash=sha256:31b2eced602aa8423c2aea9c76a724617ed67cf9513173fd3a4f03e3a929c7e6 \
    --hash=sha256:832aa3cde19744e49938b91fea06d69ecb9e649c93ba974535d08ad92164f700
autobahn==21.3.1 \
    --hash=sha256:9195df8af03b0ff29ccd4b7f5abbde957ee90273465942205f9a1bad6c3f07ac \
    --hash=sha256:e126c1f583e872fb59e79d36977cfa1f2d0a8a79f90ae31f406faae7664b8e03
Automat==20.2.0 \
    --hash=sha256:7979803c74610e11ef0c0d68a2942b152df52da55336e0c9d58daf1831cbdf33 \
    --hash=sha256:b6feb6455337df834f6c9962d6ccf771515b7d939bca142b29c20c2376bc6111
bcrypt==3.2.0 \
    --hash=sha256:5b93c1726e50a93a033c36e5ca7fdcd29a5c7395af50a6892f5d9e7c6cfbfb29 \
    --hash=sha256:63d4e3ff96188e5898779b6057878fecf3f11cfe6ec3b313ea09955d587ec7a7 \
    --hash=sha256:81fec756feff5b6818ea7ab031205e1d323d8943d237303baca2c5f9c7846f34 \
    --hash=sha256:a67fb841b35c28a59cebed05fbd3e80eea26e6d75851f0574a9273c80f3e9b55 \
    --hash=sha256:c95d4cbebffafcdd28bd28bb4e25b31c50f6da605c81ffd9ad8a3d1b2ab7b1b6 \
    --hash=sha256:cd1ea2ff3038509ea95f687256c46b79f5fc382ad0aa3664d200047546d511d1 \
    --hash=sha256:cdcdcb3972027f83fe24a48b1e90ea4b584d35f1cc279d76de6fc4b13376239d
bitstring==3.1.7 \
    --hash=sha256:fdf3eb72b229d2864fb507f8f42b1b2c57af7ce5fec035972f9566de440a864a
cbor==1.0.0 \
    --hash=sha256:13225a262ddf5615cbd9fd55a76a0d53069d18b07d2e9f19c39e6acb8609bbb6
cbor2==5.2.0 \
    --hash=sha256:a33aa2e5534fd74401ac95686886e655e3b2ce6383b3f958199b6e70a87c94bf
certifi==2020.12.5 \
    --hash=sha256:1a4995114262bffbc2413b159f2a1a480c969de6e6eb13ee966d470af86af59c \
    --hash=sha256:719a74fb9e33b9bd44cc7f3a8d94bc35e4049deebe19ba7d8e108280cfd59830
cffi==1.14.5 \
    --hash=sha256:005a36f41773e148deac64b08f233873a4d0c18b053d37da83f6af4d9087b813 \
    --hash=sha256:0857f0ae312d855239a55c81ef453ee8fd24136eaba8e87a2eceba644c0d4c06 \
    --hash=sha256:1071534bbbf8cbb31b498d5d9db0f274f2f7a865adca4ae429e147ba40f73dea \
    --hash=sha256:158d0d15119b4b7ff6b926536763dc0714313aa59e320ddf787502c70c4d4bee \
    --hash=sha256:1f436816fc868b098b0d63b8920de7d208c90a67212546d02f84fe78a9c26396 \
    --hash=sha256:2894f2df484ff56d717bead0a5c2abb6b9d2bf26d6960c4604d5c48bbc30ee73 \
    --hash=sha256:29314480e958fd8aab22e4a58b355b629c59bf5f2ac2492b61e3dc06d8c7a315 \
    --hash=sha256:34eff4b97f3d982fb93e2831e6750127d1355a923ebaeeb565407b3d2f8d41a1 \
    --hash=sha256:35f27e6eb43380fa080dccf676dece30bef72e4a67617ffda586641cd4508d49 \
    --hash=sha256:3d3dd4c9e559eb172ecf00a2a7517e97d1e96de2a5e610bd9b68cea3925b4892 \
    --hash=sha256:43e0b9d9e2c9e5d152946b9c5fe062c151614b262fda2e7b201204de0b99e482 \
    --hash=sha256:48e1c69bbacfc3d932221851b39d49e81567a4d4aac3b21258d9c24578280058 \
    --hash=sha256:51182f8927c5af975fece87b1b369f722c570fe169f9880764b1ee3bca8347b5 \
    --hash=sha256:58e3f59d583d413809d60779492342801d6e82fefb89c86a38e040c16883be53 \
    --hash=sha256:5de7970188bb46b7bf9858eb6890aad302577a5f6f75091fd7cdd3ef13ef3045 \
    --hash=sha256:65fa59693c62cf06e45ddbb822165394a288edce9e276647f0046e1ec26920f3 \
    --hash=sha256:69e395c24fc60aad6bb4fa7e583698ea6cc684648e1ffb7fe85e3c1ca131a7d5 \
    --hash=sha256:6c97d7350133666fbb5cf4abdc1178c812cb205dc6f41d174a7b0f18fb93337e \
    --hash=sha256:6e4714cc64f474e4d6e37cfff31a814b509a35cb17de4fb1999907575684479c \
    --hash=sha256:72d8d3ef52c208ee1c7b2e341f7d71c6fd3157138abf1a95166e6165dd5d4369 \
    --hash=sha256:8ae6299f6c68de06f136f1f9e69458eae58f1dacf10af5c17353eae03aa0d827 \
    --hash=sha256:8b198cec6c72df5289c05b05b8b0969819783f9418e0409865dac47288d2a053 \
    --hash=sha256:99cd03ae7988a93dd00bcd9d0b75e1f6c426063d6f03d2f90b89e29b25b82dfa \
    --hash=sha256:9cf8022fb8d07a97c178b02327b284521c7708d7c71a9c9c355c178ac4bbd3d4 \
    --hash=sha256:9de2e279153a443c656f2defd67769e6d1e4163952b3c622dcea5b08a6405322 \
    --hash=sha256:9e93e79c2551ff263400e1e4be085a1210e12073a31c2011dbbda14bda0c6132 \
    --hash=sha256:9ff227395193126d82e60319a673a037d5de84633f11279e336f9c0f189ecc62 \
    --hash=sha256:a465da611f6fa124963b91bf432d960a555563efe4ed1cc403ba5077b15370aa \
    --hash=sha256:ad17025d226ee5beec591b52800c11680fca3df50b8b29fe51d882576e039ee0 \
    --hash=sha256:afb29c1ba2e5a3736f1c301d9d0abe3ec8b86957d04ddfa9d7a6a42b9367e396 \
    --hash=sha256:b85eb46a81787c50650f2392b9b4ef23e1f126313b9e0e9013b35c15e4288e2e \
    --hash=sha256:bb89f306e5da99f4d922728ddcd6f7fcebb3241fc40edebcb7284d7514741991 \
    --hash=sha256:cbde590d4faaa07c72bf979734738f328d239913ba3e043b1e98fe9a39f8b2b6 \
    --hash=sha256:cd2868886d547469123fadc46eac7ea5253ea7fcb139f12e1dfc2bbd406427d1 \
    --hash=sha256:d42b11d692e11b6634f7613ad8df5d6d5f8875f5d48939520d351007b3c13406 \
    --hash=sha256:f2d45f97ab6bb54753eab54fffe75aaf3de4ff2341c9daee1987ee1837636f1d \
    --hash=sha256:fd78e5fee591709f32ef6edb9a015b4aa1a5022598e36227500c8f4e02328d9c
chardet==4.0.0 \
    --hash=sha256:0d6f53a15db4120f2b08c94f11e7d93d2c911ee118b6b30a04ec3ee8310179fa \
    --hash=sha256:f864054d66fd9118f2e67044ac8981a54775ec5b67aed0441892edb553d21da5
click==7.1.2 \
    --hash=sha256:d2b5255c7c6349bc1bd1e59e08cd12acbbd63ce649f2588755783aa94dfb6b1a \
    --hash=sha256:dacca89f4bfadd5de3d7489b7c8a566eee0d3676333fbb50030263894c38c0dc
colorama==0.4.4 \
    --hash=sha256:5941b2b48a20143d2267e95b1c2a7603ce057ee39fd88e7329b0c292aa16869b \
    --hash=sha256:9f47eda37229f68eee03b24b9748937c7dc3868f906e8ba69fbcbdd3bc5dc3e2
constantly==15.1.0 \
    --hash=sha256:586372eb92059873e29eba4f9dec8381541b4d3834660707faf8ba59146dfc35 \
    --hash=sha256:dd2fa9d6b1a51a83f0d7dd76293d734046aa176e384bf6e33b7e44880eb37c5d
cryptography==3.4.6 \
    --hash=sha256:066bc53f052dfeda2f2d7c195cf16fb3e5ff13e1b6b7415b468514b40b381a5b \
    --hash=sha256:0923ba600d00718d63a3976f23cab19aef10c1765038945628cd9be047ad0336 \
    --hash=sha256:2d32223e5b0ee02943f32b19245b61a62db83a882f0e76cc564e1cec60d48f87 \
    --hash=sha256:4169a27b818de4a1860720108b55a2801f32b6ae79e7f99c00d79f2a2822eeb7 \
    --hash=sha256:57ad77d32917bc55299b16d3b996ffa42a1c73c6cfa829b14043c561288d2799 \
    --hash=sha256:5ecf2bcb34d17415e89b546dbb44e73080f747e504273e4d4987630493cded1b \
    --hash=sha256:600cf9bfe75e96d965509a4c0b2b183f74a4fa6f5331dcb40fb7b77b7c2484df \
    --hash=sha256:66b57a9ca4b3221d51b237094b0303843b914b7d5afd4349970bb26518e350b0 \
    --hash=sha256:93cfe5b7ff006de13e1e89830810ecbd014791b042cbe5eec253be11ac2b28f3 \
    --hash=sha256:9e98b452132963678e3ac6c73f7010fe53adf72209a32854d55690acac3f6724 \
    --hash=sha256:df186fcbf86dc1ce56305becb8434e4b6b7504bc724b71ad7a3239e0c9d14ef2 \
    --hash=sha256:fec7fb46b10da10d9e1d078d1ff8ed9e05ae14f431fdbd11145edd0550b9a964
flatbuffers==1.12 \
    --hash=sha256:63bb9a722d5e373701913e226135b28a6f6ac200d5cc7b4d919fa38d73b44610 \
    --hash=sha256:9e9ef47fa92625c4721036e7c4124182668dc6021d9e7c73704edd395648deb9
h2==4.0.0 \
    --hash=sha256:ac9e293a1990b339d5d71b19c5fe630e3dd4d768c620d1730d355485323f1b25 \
    --hash=sha256:bb7ac7099dd67a857ed52c815a6192b6b1f5ba6b516237fc24a085341340593d
hpack==4.0.0 \
    --hash=sha256:84a076fad3dc9a9f8063ccb8041ef100867b1878b25ef0ee63847a5d53818a6c \
    --hash=sha256:fc41de0c63e687ebffde81187a948221294896f6bdc0ae2312708df339430095
hyperframe==6.0.0 \
    --hash=sha256:742d2a4bc3152a340a49d59f32e33ec420aa8e7054c1444ef5c7efff255842f1 \
    --hash=sha256:a51026b1591cac726fc3d0b7994fbc7dc5efab861ef38503face2930fd7b2d34
hyperlink==21.0.0 \
    --hash=sha256:427af957daa58bc909471c6c40f74c5450fa123dd093fc53efd2e91d2705a56b \
    --hash=sha256:e6b14c37ecb73e89c77d78cdb4c2cc8f3fb59a885c5b3f819ff4ed80f25af1b4
idna==2.5 \
    --hash=sha256:3cb5ce08046c4e3a560fc02f138d0ac63e00f8ce5901a56b32ec8b7994082aab \
    --hash=sha256:cc19709fd6d0cbfed39ea875d29ba6d4e22c0cebc510a76d6302a28385e8bb70
importlib-resources==5.1.1 \
    --hash=sha256:563c5579cd40a7d5c6256ea6519b510152b6968103ab540b9771a50093a09056 \
    --hash=sha256:67bcf65e7b9f7f2ea54a342254c7e87607819955469034bc581fae26e1743306
incremental==21.3.0 \
    --hash=sha256:02f5de5aff48f6b9f665d99d48bfc7ec03b6e3943210de7cfc88856d755d6f57 \
    --hash=sha256:92014aebc6a20b78a8084cdd5645eeaa7f74b8933f70fa3ada2cfbd1e3b54321
Jinja2==2.11.3 \
    --hash=sha256:03e47ad063331dd6a3f04a43eddca8a966a26ba0c5b7207a9a9e4e08f1b29419 \
    --hash=sha256:a6d58433de0ae800347cab1fa3043cebbabe8baa9d29e668f1c768cb87a333c6
lmdb==1.1.1 \
    --hash=sha256:13070c5a11ad5926237f71ff811320e84a0a662ee521a4010f774dedefdf0fa9 \
    --hash=sha256:165cd1669b29b16c2d5cc8902b90fede15a7ee475c54d466f1444877a3f511ac \
    --hash=sha256:329bf470e695b2f5992aaba43f3aedeb3905ab4f36ec13c28fca916294b54907 \
    --hash=sha256:45846011e833cf3ea25396a2ea019f80ce33b7b66f4ae22342205eb61ea7e514 \
    --hash=sha256:61bdb679c05a176c61090d6b72a05128b7c0263653cc2ada8719cdc5b3d28ac7 \
    --hash=sha256:666dd52f69fa5c1747e4c944448f32270178d29c974f72db42e5fb65a1707293 \
    --hash=sha256:699cfdbbc58d0042bbae551d162b09180155667eda129e4eb5cc0b683583826a \
    --hash=sha256:6ddb6260d9e9f41c3a9a9a3b83af252cdd4f3e2d4116182e7f04fad38a33f82b \
    --hash=sha256:793837ff38c1210fef7b9fb9b44799d5beab409b451322b02c8059cddc3b6334 \
    --hash=sha256:8c9e1dd1d03b8c2b0a826a841401416e0fa7925b77e4622aaef7a0492834f022 \
    --hash=sha256:94e0e4aedfdcb2b1c93acf5018a41b9e4f25b059afe820568475216014715fe2 \
    --hash=sha256:957db1ce4322916930732e9718081198fbd4d92d87d3215a12c2ccffbbe1160a \
    --hash=sha256:98d7e8be2a05fe3af0cf7074b0cefe4de82e81ec7665db0dc1c5cd891aefcfe9 \
    --hash=sha256:a8b7ce34a717df6f00d6089e873d45015eee70b4cb68f238c70626c2a588f659 \
    --hash=sha256:adf5da578fc7377fa36e9613e4883587c5382420a4f77d63ad78c34769722c19 \
    --hash=sha256:b6e87cf3613ba9ac063c6b27b5c76b4687e893d1db38e41ae038824e87849684 \
    --hash=sha256:c74788f4b6dc4383117716c2c5c1fd6766654ce0cf2e9e0baf8e6b4d8491c611 \
    --hash=sha256:cf07566bf6497fba224f56cc4f99b0ea5636dd163d540d9020e917b155f2235d \
    --hash=sha256:d993ccc3142439be7231e70150e40ed59b9cd58517f35a280b8c84ab40bbc299 \
    --hash=sha256:e14b12a0994df68d76ac6665de6bdd04cef2d5816bdf3bd93a19dd5fc6bd1917 \
    --hash=sha256:f111c0d924d0ee919471335fb27cdc605749d09c5c46baa7d3a58142b733746a \
    --hash=sha256:f8ee147d5ef7648d1ab3d3ff1af5987b1d44f76a759b10c54872599f1e767b85 \
    --hash=sha256:fa82eac04b2625e45b9a5e14086b1428f77485fc9e0b7e3e59918c8a28b1928c
MarkupSafe==1.1.1 \

=== docker/Makefile ===
default:
	@echo ""
	@echo "Targets:"
	@echo ""
	@echo "  params                 Print build parameter"
	@echo "  build                  Build images"
	@echo "  version                Print version of images"
	@echo "  test                   Test images"
	@echo "  publish                Publish images"
	@echo ""


params:
	@echo "${CROSSBAR_VERSION}"
	@echo "${CROSSBAR_VCS_REF}"
	@echo "${BUILD_DATE}"

build: build_cpy3 build_pypy3

version: version_cpy3 version_pypy3

test: test_cpy3 test_pypy3

download_wheels:
	mkdir -p ./.wheels/
	rm -f ./.wheels/*.whl
	curl -o ./.wheels/txaio-latest-py2.py3-none-any.whl       https://crossbarbuilder.s3.eu-central-1.amazonaws.com/wheels/txaio-latest-py2.py3-none-any.whl
	curl -o ./.wheels/autobahn-latest-py2.py3-none-any.whl    https://crossbarbuilder.s3.eu-central-1.amazonaws.com/wheels/autobahn-latest-py2.py3-none-any.whl
	curl -o ./.wheels/zlmdb-latest-py2.py3-none-any.whl       https://crossbarbuilder.s3.eu-central-1.amazonaws.com/wheels/zlmdb-latest-py2.py3-none-any.whl

prepare:
	-rm -rf ./node
	crossbar init --appdir ./node
	mkdir node/web/js -p

publish_amd64_cpy3:
	# amd64 / community / cpy3
	docker push crossbario/crossbar:cpy-amd64
	docker push crossbario/crossbar:cpy-amd64-${CROSSBAR_VERSION}

publish_amd64_pypy3:
	# amd64 / community / pypy3
	docker push crossbario/crossbar:pypy-amd64
	docker push crossbario/crossbar:pypy-amd64-${CROSSBAR_VERSION}

publish_armhf_cpy3:
	# armhf / community / cpy3
	docker push crossbario/crossbar:cpy-armhf
	docker push crossbario/crossbar:cpy-armhf-${CROSSBAR_VERSION}

	# armhf / community / pypy3
	# docker push crossbario/crossbar-armhf:pypy3
	# docker push crossbario/crossbar-armhf:pypy3-${CROSSBAR_VERSION}

publish_aarch64_cpy3:
	# aarch64 / community / cpy3
	docker push crossbario/crossbar:cpy-arm64v8
	docker push crossbario/crossbar:cpy-arm64v8-${CROSSBAR_VERSION}

publish_aarch64_pypy3:
	# aarch64 / community / pypy3
	docker push crossbario/crossbar:pypy-arm64v8
	docker push crossbario/crossbar:pypy-arm64v8-${CROSSBAR_VERSION}

trigger_microbadger:
	# trigger updates of metainfo on https://microbadger.com/
	curl -X POST https://hooks.microbadger.com/images/crossbario/crossbar/jA-pM9fXwd6v4Q7M3PWGG10XPAE=
	curl -X POST https://hooks.microbadger.com/images/crossbario/crossbar-armhf/3hB5Fn-4Bf2VV9ihB8e7v687Y60=
	curl -X POST https://hooks.microbadger.com/images/crossbario/crossbar-aarch64/ekMu3620yWLtfpxIqJQgPSmDNYE=


requirements:
	sudo apt-get update
	sudo apt-get install -y qemu qemu-kvm qemu-system qemu-system-x86 qemu-system-arm
	sudo apt-get install -y --no-install-recommends qemu-user-static binfmt-support
	sudo update-binfmts --enable qemu-arm
	sudo update-binfmts --enable qemu-aarch64
	sudo update-binfmts --display qemu-arm
	sudo update-binfmts --display qemu-aarch64

# Install Qemu (this is needed for cross-building armhf/aarch64 on amd64)
qemu_deps:
	mkdir -p ./.qemu
	cp /usr/bin/qemu-system-aarch64 ./.qemu
	cp /usr/bin/qemu-system-arm ./.qemu

#
# Copy over current AutobahnJS into the default node directory
# we bake into the images
#
autobahn:
	mkdir -p ./.node/web/js/
	cp ../../autobahn-js-browser/autobahn.* ./.node/web/js/
	cp ../../autobahn-js-browser/CHECKSUM.* ./.node/web/js/
	cp ../../autobahn-js-browser/LICENSE ./.node/web/js/

#
# List all images
#
list:
	-docker images crossbario/crossbar*

#
# Remove all images !!!
#
clean:
	./removeall.sh


download_wheels:
	mkdir -p ./.wheels/
	rm -f ./.wheels/*.whl
	curl -o ./.wheels/txaio-latest-py2.py3-none-any.whl       https://crossbarbuilder.s3.eu-central-1.amazonaws.com/wheels/txaio-latest-py2.py3-none-any.whl
	curl -o ./.wheels/autobahn-latest-py2.py3-none-any.whl    https://crossbarbuilder.s3.eu-central-1.amazonaws.com/wheels/autobahn-latest-py2.py3-none-any.whl
	curl -o ./.wheels/zlmdb-latest-py2.py3-none-any.whl       https://crossbarbuilder.s3.eu-central-1.amazonaws.com/wheels/zlmdb-latest-py2.py3-none-any.whl
	curl -o ./.wheels/crossbar-latest-py2.py3-none-any.whl    https://crossbarbuilder.s3.eu-central-1.amazonaws.com/wheels/crossbar-latest-py2.py3-none-any.whl

#
# BUILD: Community / CPython 3
#
build_cpy3: build_amd64_cpy3 build_armhf_cpy3 build_aarch64_cpy3

build_amd64_cpy3:
	# enforce auto-generating a new key when using the images
	rm -f node/.crossbar/key.*
	time docker build \
		--build-arg CROSSBAR_ARCH=amd64 \
		--build-arg CROSSBAR_BUILD_DATE=${CROSSBAR_BUILD_DATE} \
		--build-arg CROSSBAR_VCS_REF=${CROSSBAR_VCS_REF} \
		--build-arg CROSSBAR_VERSION=${CROSSBAR_VERSION} \
		-t crossbario/crossbar:cpy-amd64 \
		-t crossbario/crossbar:cpy-amd64-${CROSSBAR_VERSION} \
		-f Dockerfile.cpy-slim \
		.
	docker images crossbario/crossbar:cpy-amd64

build_aarch64_cpy3:
	# enforce auto-generating a new key when using the images
	rm -f node/.crossbar/key.*
	docker build \
		--build-arg CROSSBAR_ARCH=arm64v8 \
		--build-arg BUILD_DATE=${CROSSBAR_BUILD_DATE} \
		--build-arg CROSSBAR_VCS_REF=${CROSSBAR_VCS_REF} \
		--build-arg CROSSBAR_VERSION=${CROSSBAR_VERSION} \
		-t crossbario/crossbar:cpy-arm64v8 \
		-t crossbario/crossbar:cpy-arm64v8-${CROSSBAR_VERSION} \
		-f ./Dockerfile.cpy-slim .
	docker images crossbario/crossbar:cpy-arm64v8

build_armhf_cpy3:
	# enforce auto-generating a new key when using the images
	rm -f node/.crossbar/key.*
	time docker build \
		--build-arg CROSSBAR_ARCH=armhf \
		--build-arg CROSSBAR_BUILD_DATE=${CROSSBAR_BUILD_DATE} \
		--build-arg CROSSBAR_VCS_REF=${CROSSBAR_VCS_REF} \
		--build-arg CROSSBAR_VERSION=${CROSSBAR_VERSION} \
		-t crossbario/crossbar:cpy-armhf \
		-t crossbario/crossbar:cpy-armhf-${CROSSBAR_VERSION} \
		-f Dockerfile.cpy-slim \
		.
	docker images crossbario/crossbar:cpy-armhf


#
# BUILD: Community / PyPy 3
#
build_pypy3: build_amd64_pypy3 build_armhf_pypy3 build_aarch64_pypy3

build_amd64_pypy3:
	# enforce auto-generating a new key when using the images
	rm -f node/.crossbar/key.*
	time docker build \
		--build-arg CROSSBAR_ARCH=amd64 \
		--build-arg CROSSBAR_BUILD_DATE=${CROSSBAR_BUILD_DATE} \
		--build-arg CROSSBAR_VCS_REF=${CROSSBAR_VCS_REF} \
		--build-arg CROSSBAR_VERSION=${CROSSBAR_VERSION} \
		-t crossbario/crossbar:pypy-amd64 \
		-t crossbario/crossbar:pypy-amd64-${CROSSBAR_VERSION} \
		-f Dockerfile.pypy-slim \
		.
	docker images crossbario/crossbar:pypy-amd64

build_aarch64_pypy3:
	# enforce auto-generating a new key when using the images
	rm -f node/.crossbar/key.*
	docker build \
		--build-arg CROSSBAR_ARCH=arm64v8 \
		--build-arg BUILD_DATE=${CROSSBAR_BUILD_DATE} \
		--build-arg CROSSBAR_VCS_REF=${CROSSBAR_VCS_REF} \
		--build-arg CROSSBAR_VERSION=${CROSSBAR_VERSION} \
		-t crossbario/crossbar:pypy-arm64v8 \
		-t crossbario/crossbar:pypy-arm64v8-${CROSSBAR_VERSION} \
		-f ./Dockerfile.pypy-slim .
	docker images crossbario/crossbar:pypy-arm64v8

build_armhf_pypy3:
	@echo "PyPy3 isn't available for armhf yet"


#
# VERSION: Community / CPython 3
#
version_cpy3: version_amd64_cpy3 version_armhf_cpy3 version_aarch64_cpy3

version_amd64_cpy3:
	docker run \
		--rm --entrypoint=/usr/local/bin/crossbar -it \
		crossbario/crossbar:cpy-amd64-${CROSSBAR_VERSION} version

version_armhf_cpy3:
	docker run \
		--rm --entrypoint=/usr/local/bin/crossbar -it \
		crossbario/crossbar:cpy-armhf-${CROSSBAR_VERSION} version

version_aarch64_cpy3:
	docker run \
		--rm --entrypoint=/usr/local/bin/crossbar -it \
		crossbario/crossbar:cpy-arm64v8-${CROSSBAR_VERSION} version


#
# VERSION: Community / PyPy 3
#
version_pypy3: version_amd64_pypy3 version_armhf_pypy3 version_aarch64_pypy3

version_amd64_pypy3:
	docker run \
		--rm --entrypoint=/usr/local/bin/crossbar -it \
		crossbario/crossbar:pypy-amd64-${CROSSBAR_VERSION} version

version_armhf_pypy3:
	@echo "PyPy3 isn't available for armhf yet"

version_aarch64_pypy3:
	docker run \
		--rm --entrypoint=/usr/local/bin/crossbar -it \
		crossbario/crossbar:pypy-arm64v8-${CROSSBAR_VERSION} version


#
# TEST: Community / CPython 3
#
test_cpy3: test_amd64_cpy3 test_armhf_cpy3 test_aarch64_cpy3

test_amd64_cpy3:
	docker run \
		--rm -it -p 8080:8080 --name crossbar \
		crossbario/crossbar:cpy-amd64-${CROSSBAR_VERSION}

test_armhf_cpy3:
	docker run \
		--rm -it -p 8080:8080 --name crossbar \
		crossbario/crossbar:cpy-armhf-${CROSSBAR_VERSION}

test_aarch64_cpy3:
	docker run \
		--rm -it -p 8080:8080 --name crossbar \
		crossbario/crossbar:cpy-arm64v8-${CROSSBAR_VERSION}


#
# TEST: Community / PyPy 3
#
test_pypy3: test_amd64_pypy3 test_armhf_pypy3 test_aarch64_pypy3

test_amd64_pypy3:
	docker run \
		--rm -it -p 8080:8080 --name crossbar \
		crossbario/crossbar:pypy-amd64-${CROSSBAR_VERSION}

test_armhf_pypy3:
	@echo "PyPy3 isn't available for armhf yet"

test_aarch64_pypy3:
	docker run \
		--rm -it -p 8080:8080 --name crossbar \
		crossbario/crossbar:pypy-arm64v8-${CROSSBAR_VERSION}

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = Crossbario
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== debian/changelog ===
crossbar (21.3.1+dfsg-3) unstable; urgency=medium

  * Use escape from markupsafe (Closes: #1013228)

 -- Bastian Germann <bage@debian.org>  Wed, 14 Sep 2022 16:46:24 +0200

crossbar (21.3.1+dfsg-2) unstable; urgency=medium

  * Source-only reupload

 -- Bastian Germann <bage@debian.org>  Fri, 15 Apr 2022 13:52:50 +0200

crossbar (21.3.1+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #822183)

 -- Bastian Germann <bage@debian.org>  Thu, 17 Feb 2022 03:18:04 +0100

=== debian/control ===
Source: crossbar
Section: python
Priority: optional
Maintainer: Bastian Germann <bage@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 python3-setuptools,
 python3-all,
 python3-attr,
 python3-autobahn,
 python3-bitstring,
 python3-bcrypt,
 python3-cbor,
 python3-click,
 python3-colorama,
 python3-constantly,
 python3-cryptography,
 python3-h2,
 python3-idna,
 python3-importlib-resources,
 python3-incremental,
 python3-jinja2,
 python3-lmdb,
 python3-mistune,
 python3-mock,
 python3-netaddr,
 python3-passlib,
 python3-priority,
 python3-psutil,
 python3-ubjson,
 python3-pyasn1-modules,
 python3-pyasn1,
 python3-pygments,
 python3-nacl,
 python3-openssl,
 python3-pyqrcode,
 python3-trie,
 python3-yaml,
 python3-sdnotify,
 python3-setproctitle,
 python3-sphinx,
 python3-sphinxcontrib.spelling,
 python3-sphinxcontrib.websupport,
 python3-treq,
 python3-twisted,
 python3-txaio,
 python3-txtorcon,
 python3-u-msgpack,
 python3-urllib3,
 python3-watchdog,
 python3-werkzeug,
 python3-wsaccel,
 python3-zlmdb,
 python3-zope.interface
Standards-Version: 4.6.0
Homepage: https://github.com/crossbario/crossbar
Vcs-Browser: https://salsa.debian.org/python-team/packages/crossbar
Vcs-Git: https://salsa.debian.org/python-team/packages/crossbar.git
Testsuite: autopkgtest-pkg-python
Rules-Requires-Root: no

Package: python3-crossbar
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}, python3-markupsafe
Suggests: python-crossbar-doc
Description: Multi-protocol application router for microservices (Python 3)
 Crossbar.io is an open source networking platform for distributed and
 microservice applications. It implements the open Web Application Messaging
 Protocol (WAMP), is feature rich, scalable, robust and secure.
 .
 This package installs the library for Python 3.

Package: python-crossbar-doc
Architecture: all
Section: doc
Depends: ${sphinxdoc:Depends}, ${misc:Depends}
Description: Multi-protocol application router for microservices (common documentation)
 Crossbar.io is an open source networking platform for distributed and
 microservice applications. It implements the open Web Application Messaging
 Protocol (WAMP), is feature rich, scalable, robust and secure.
 .
 This is the common documentation package.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=crossbar

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild


override_dh_auto_build: export http_proxy=127.0.0.1:9
override_dh_auto_build: export https_proxy=127.0.0.1:9
override_dh_auto_build:
	dh_auto_build
	PYTHONPATH=. python3 -m sphinx -N -bhtml docs/ build/html

override_dh_compress-indep:
	dh_compress -Xchangelog.html

=== debian/watch ===
version=4
opts="compression=gzip,repacksuffix=+dfsg,dversionmangle=auto" \
  https://github.com/crossbario/crossbar/tags (?:.*?/)?v(\d[\d\.]*)\.tar\.gz
